/*!
 * SAP UI development toolkit for HTML5 (SAPUI5)

(c) Copyright 2009-2016 SAP SE. All rights reserved
 */
sap.ui.define(['sap/ui/core/Element','sap/viz/library'],function(E,l){"use strict";var D=E.extend("sap.viz.ui5.data.DimensionDefinition",{metadata:{library:"sap.viz",properties:{axis:{type:"int",group:"Misc",defaultValue:null},value:{type:"any",group:"Data",defaultValue:null},name:{type:"string",group:"Misc",defaultValue:null},identity:{type:"string",group:"Misc",defaultValue:null},displayValue:{type:"any",group:"Data",defaultValue:null},dataType:{type:"string",group:"Misc",defaultValue:null}}}});D.prototype._getAdapter=function(){var t=this,b=this.getBindingInfo("value"),v,p,T,f;if(!b){v=this.getValue();return function(){return v;};}if(b.parts.length>1){throw new Error("DimensionDefinition doesn't support calculated bindings yet");}p=b.parts[0].path;T=b.parts[0].type;f=b.formatter;if(!(T||f)){return function(c){return c.getProperty(p);}}return function(c){var v=c.getProperty(p);if(T){v=T.formatValue(v,"string");}if(f){v=f.call(t,v,c);}return v;};};D.prototype._getDisplayValueAdapter=function(){var t=this,b=this.getBindingInfo("displayValue"),v,p,T,f,a;if(!b){v=this.getValue();return function(){return{"enableDisplayValue":false,"value":v};};}p=b.parts[0].path;T=b.parts[0].type;a=b.parts;f=b.formatter;if(a.length==1&&!(T||f)){return function(c){return{"enableDisplayValue":true,"value":c.getProperty(p)};}}return function(c){if(a.length>0){var d=[];for(var i=0;i<a.length;i++){d.push(c.getProperty(a[i].path));}if(f){v=f.apply(t,d);}}return{"enableDisplayValue":true,"value":v};};};D.prototype.setInResult=function(i){this._bInResult=!!i;};D.prototype.getInResult=function(){return this._bInResult;};return D;});
